// BBSからRSSを読んで表示するオブジェクト

function ActorBBS() {
	var obj = document.getElementById("words");
	obj.setAttribute("style", "white-space:normal;width:150px;cursor:default;");
	return this;
}

ActorBBS.prototype = {
	rssType:"RSS1.0",
	linkLocation : null,
	xmlDoc : null,

	// isShow : boolean : 読み込み後、台詞表示をするか
	initSection:function (isShow) {
		var rssLocation = getLocalizedString("URL_BBS");
		//var rssLocation = "index.rdf";
		this.requestFile(rssLocation, isShow);
	},

	// 終了前処理
	removeActor:function () {
	},

	//--  台詞の更新 --
	dialog :function () {
		if ( !this.xmlDoc ) return;	
		
		// 台詞の更新
	    try {
			var resutlObj  = this.getRSS1();
	    } catch (ex) {
			var resutlObj = {description:getLocalizedString("error_dontKnow"),face:"sad",length:1};
			this.linkLocation = null;
		}
		
		var obj = document.getElementById("words");
		
		obj.innerHTML = resutlObj.description;
		updateImg(resutlObj.face);
			
		
		if (resutlObj.length == 0) this.initSection(false);
	},

	getRSS1:function () {
		// 1.0系列(RDF Site Summary)
		var rss1NS = "http://purl.org/rss/1.0/";
		var itemList = this.xmlDoc.getElementsByTagNameNS(rss1NS,"item");
		var pNo = Math.floor(Math.random()*itemList.length);
		var theDescription = itemList[pNo].getElementsByTagNameNS(rss1NS,"description")[0].firstChild.nodeValue;
		var dcNS = "http://purl.org/dc/elements/1.1/";
		var theSubject = itemList[pNo].getElementsByTagNameNS(dcNS,"subject")[0].firstChild.nodeValue;
		itemList[pNo].parentNode.removeChild(itemList[pNo]);
		return {description:theDescription,length:itemList.length,face:theSubject};
	},

	// isShowは読み込み後、台詞を表示するか
	requestFile:function (fileURI,isShow) {
		this.xmlDoc = null;
		//XMLHttpRequestオブジェクト生成
		var httpObj = new XMLHttpRequest();
		
		// onloadの中はthisが呼び出し元(window)になるので
		// このオブジェクトへの参照として、selfを用意しておく。
		var self = this;
		// 受信完了イベント
		httpObj.onreadystatechange = function () {
			var wordsObj = document.getElementById("words");
			if (httpObj.readyState != 4) {
				if (isShow) wordsObj.innerHTML = getLocalizedString("dialog_rssReading");
			} else if (httpObj.status != 200 && httpObj.status != undefined) {
				if (httpObj.status == 404) {
					wordsObj.innerHTML = "404 Not Found";
				} else {
					wordsObj.innerHTML = httpObj.status + getLocalizedString("error_status");
				}
				updateImg("sad");
			} else if (httpObj.responseXML == null) {
				wordsObj.innerHTML = getLocalizedString("error_parse");
				updateImg("sad");
			} else {
				self.xmlDoc  = httpObj.responseXML;
				if (isShow) self.dialog();
			}
		}
		httpObj.overrideMimeType("text/xml");
		httpObj.setRequestHeader("Cache-Control", "no-cache");
		httpObj.open("GET" , fileURI , true);
		httpObj.send(null);
	}
}
