// RSSのためのオブジェクト

function ActorRSS() {
	var obj = document.getElementById("words");
	obj.setAttribute("style", "white-space:normal;width:150px;cursor:pointer;");
	obj.addEventListener("click", this.click, true);
	obj.addEventListener("mouseover", this.mouseover, true);
	obj.addEventListener("mouseout", this.mouseout, true);
	return this;
}

ActorRSS.prototype = {
	rssType:null,
	linkLocation : null,
	xmlDoc : null,

	mouseover:function () {
		this.style.textDecoration = "underline";
	},
	mouseout:function () {
		this.style.textDecoration = "none";
	},

	// isShow : boolean : 読み込み後、台詞表示をするか
	initSection:function (isShow) {
		var rssLocation = document.getElementById("rssLocation").value;
		this.requestFile(rssLocation, isShow);
	},

	click:function () {
		widget.openURL(ACTOR.linkLocation);
	},

	// 終了前処理
	removeActor:function () {
		var obj = document.getElementById("words");
		obj.removeEventListener("click", this.click,true);
		obj.removeEventListener("mouseover", this.mouseover,true);
		obj.removeEventListener("mouseout", this.mouseout,true);
	},

	//--  台詞の更新 --
	dialog :function () {
		if ( !this.xmlDoc ) return;	
		
		// 台詞の更新
	    try {
			switch (this.rssType) {
			case "RSS1.0" :
				var resutlObj  = this.getRSS1();break;
			case "RSS2.0" :
				var resutlObj  = this.getRSS2();break;
			case "Atom" :
				var resutlObj  = this.getAtom();break;
			default :
				var resutlObj = {title:getLocalizedString("error_isThisRSS"),site:"",length:1};
				updateImg("sad");
				this.linkLocation = null;
			}
	    } catch (ex) {
			var resutlObj = {title:getLocalizedString("error_dontKnow"),site:"",length:1};
			this.linkLocation = null;
		}
		
		var obj = document.getElementById("words");
		if (resutlObj.site == "") {
			obj.innerHTML = resutlObj.title;
			updateImg("sad");
		} else {
			obj.innerHTML = resutlObj.site +getLocalizedString("dialog_pressWrote")+"<br />"+ resutlObj.title;
			updateImg("idle");
		}
		
		if (resutlObj.length == 0) this.initSection(false);
	},

	getRSS1:function () {
		// 1.0系列(RDF Site Summary)
		var rss1NS = "http://purl.org/rss/1.0/";
		var siteTitle = this.xmlDoc.getElementsByTagNameNS(rss1NS,"channel")[0].getElementsByTagNameNS(rss1NS,"title")[0].firstChild.nodeValue;
		var itemList = this.xmlDoc.getElementsByTagNameNS(rss1NS,"item");
		var pNo = Math.floor(Math.random()*itemList.length);
		var theTitle = itemList[pNo].getElementsByTagNameNS(rss1NS,"title")[0].firstChild.nodeValue;
		this.linkLocation =itemList[pNo].getElementsByTagNameNS(rss1NS,"link")[0].firstChild.nodeValue;
		var dcNS = "http://purl.org/dc/elements/1.1/";
		//var theDate = itemList[pNo].getElementsByTagNameNS(dcNS,"date")[0].firstChild.nodeValue;
		itemList[pNo].parentNode.removeChild(itemList[pNo]);
		return {title:theTitle,length:itemList.length,site:siteTitle};
	},

	getRSS2:function () {
		// 0.91-2.0系列(Rich Site Summary-Really Simple Syndication)
		var siteTitle = this.xmlDoc.getElementsByTagName("channel")[0].getElementsByTagName("title")[0].firstChild.nodeValue;
		var itemList = this.xmlDoc.getElementsByTagName("item");
		var pNo = Math.floor(Math.random()*itemList.length);
		var theTitle = itemList[pNo].getElementsByTagName("title")[0].firstChild.nodeValue;
		this.linkLocation =itemList[pNo].getElementsByTagName("link")[0].firstChild.nodeValue;
		itemList[pNo].parentNode.removeChild(itemList[pNo]);
		return {title:theTitle,length:itemList.length,site:siteTitle};
	},

	getAtom:function () {
		// Atom
		var atomNS = "http://purl.org/atom/ns#";
		var siteTitle = this.xmlDoc.getElementsByTagNameNS(atomNS,"title")[0].firstChild.nodeValue;
		var itemList = this.xmlDoc.getElementsByTagNameNS(atomNS,"entry");
		var pNo = Math.floor(Math.random()*itemList.length);
		var theTitle = itemList[pNo].getElementsByTagNameNS(atomNS,"title")[0].firstChild.nodeValue;
		this.linkLocation =itemList[pNo].getElementsByTagNameNS(atomNS,"link")[0].getAttribute("href");
		itemList[pNo].parentNode.removeChild(itemList[pNo]);
		return {title:theTitle,length:itemList.length,site:siteTitle};
	},
	
	// isShowは読み込み後、台詞を表示するか
	requestFile:function (fileURI,isShow) {
		this.xmlDoc = null;
		//XMLHttpRequestオブジェクト生成
		var httpObj = new XMLHttpRequest();
		
		// onloadの中はthisが呼び出し元(window)になるので
		// このオブジェクトへの参照として、selfを用意しておく。
		var self = this;
		// 受信完了イベント
		httpObj.onreadystatechange = function () {
			var wordsObj = document.getElementById("words");
			if (httpObj.readyState != 4) {
				if (isShow) wordsObj.innerHTML = getLocalizedString("dialog_rssReading");
			} else if (httpObj.status != 200 && httpObj.status != undefined) {
				if (httpObj.status == 404) {
					wordsObj.innerHTML = "404 Not Found";
				} else {
					wordsObj.innerHTML = httpObj.status + getLocalizedString("error_status");
				}
				updateImg("sad");
			} else if (httpObj.responseXML == null) {
				wordsObj.innerHTML = getLocalizedString("error_parse");
				updateImg("sad");
			} else {
				self.xmlDoc  = httpObj.responseXML;
				self.setRssType();
				if (isShow) self.dialog();
			}
		}
		httpObj.overrideMimeType("text/xml");
		//httpObj.setRequestHeader("Cache-Control", "no-cache");
		httpObj.open("GET" , fileURI , true);
		httpObj.send(null);
	},
	
	// 最初のタグ名と、対応した属性でRSSのタイプを判定
	// 見ての通り、3種類を荒っぽく判定している
	setRssType :function () {
		this.rssType = null;
		var docEle = this.xmlDoc.documentElement;
		switch (docEle.tagName) {
		case "rdf:RDF" :
			if (docEle.getAttribute("xmlns") == "http://purl.org/rss/1.0/") this.rssType = "RSS1.0";
			break;
		case "rss" :     
			if (docEle.getAttribute("version") == "2.0") this.rssType = "RSS2.0";
			break;
		case "feed" :
			if (docEle.getAttribute("xmlns") == "http://purl.org/atom/ns#") {
				this.rssType = "Atom";//+this.xmlDoc.firstChild.getAttribute("version");
			}
			break;
		}
	}
}
