var timeoutID = null;
var ACTOR;
var tieSelector;
var tieBtn = new Array();

// ウィジェットの初期化
// 主に、保存された設定の読み込みを行う
function setup() {
	if (window.widget) {
		widget.onhide = onhide;
		widget.onshow = onshow;
		resizeBy(150, 0);
	}
	// 初期設定
	Pref.load("act", "tips");	// アクションの種類
	Pref.load("section", "Dashboard");	// お話の種類
	Pref.load("rssLocation", "http://www.apple.com/jp/main/rss/hotnews/hotnews.rss");	// RSSの場所
	
	setTieControl();//ネクタイの色
	Pref.load("skin", "Swim");	// スキンの種類
	document.getElementById("mainImg").src = "Images/"+Pref.getValue("skin")+".png";

	inputPerfTab();// タブ
	selectAct(document.getElementById("act").value);

	// ActorObjを設定して初期化
	setActor();
	ACTOR.initSection(false);
	
	// 裏面の表示
	setLabel("action");
	setLabel("view");
	setLabel("about");
	//setLabel("URL_BBS");
	
	setLabel("title_BBS");
	setLabel("title_skin");
	setLabel("title_tie");
	setLabel("title_section");
	setLabel("title_developer");
	setLabel("developer");
	setLabel("title_rssLocation");
}

// タブ設定を読み込む
function inputPerfTab() {
	var  v;
	if (window.widget) {
		v = widget.preferenceForKey("pref_tab");
	}
	if (!v) v = "action";
	selectTab(document.getElementById(v));
}

//-- 初期設定の選択 --
// タブの選択
function selectTab(obj) {
	var nodeList=obj.parentNode.getElementsByTagName('li');

	for (var i = 0;i < nodeList.length;i++) {
		if (nodeList[i] == obj) {
			nodeList[i].setAttribute("style","border-style:groove;");
			document.getElementById("pref_"+nodeList[i].id).style.display="block";
		} else {
			nodeList[i].setAttribute("style","border-style:none;");
			document.getElementById("pref_"+nodeList[i].id).style.display="none";
		}
	}
	
	if (window.widget) {
		widget.setPreferenceForKey(obj.id,"pref_tab");
	}
}

// ネクタイの選択
function selectTie() {
	document.getElementById("tie_selector").style.left = (getLeft(this) - 3)+"px";
	var n = this.alt;
	document.getElementById("tieImg").src = "Images/tie/"+n+".png";
	if (window.widget) {
		widget.setPreferenceForKey(n,"tie");
	}
}

// ネクタイ選択ボタンの生成
function setTieControl() {
	var tieColors  = document.getElementById("tie");
	
	for (var i  = 0;i  < 8;i++) {
		tieBtn[i] =  document.createElement("img");
		tieBtn[i].src = "Images/label/"+i+".png";
		tieBtn[i].style.position = "absolute";
		if (i == 0) {
			tieBtn[i].style.left = "20px";
		} else {
			tieBtn[i].style.left = (25+i*16)+"px";
		}
		tieBtn[i].style.top = "60px";
		tieBtn[i].alt = i;
		tieBtn[i].addEventListener("mouseover", function () {
			var obj = document.getElementById("tie_pressed");
			obj.style.left = (getLeft(this) - 3)+"px";
			obj.style.display = "block";
		}, true);
		tieBtn[i].addEventListener("mouseup", selectTie,true);
		tieColors.appendChild(tieBtn[i]);
	}
	tieColors.addEventListener("mouseout", function () {
			var obj = document.getElementById("tie_pressed");
			obj.style.display = "none";
	},true);
	if (window.widget) {
		var n = widget.preferenceForKey("tie");
		if (!n) n = 7;
	} else {
		var n = 7;
	}
	document.getElementById("tie_selector").style.left = (getLeft(tieBtn[n]) - 3)+"px";
	document.getElementById("tieImg").src = "Images/tie/"+n+".png";
}

// Leftからpxを取り除き、数字だけを返します
function getLeft(obj) {
	//return obj.style.left.slice(0,-2); // こんな面倒な事しなくて良かった…
	return parseInt(obj.style.left);
}

// 会話の種類の設定変更
function selectAct(v) {	
	var  tipsObj  = document.getElementById("act_tips");
	var  rssObj  = document.getElementById("act_rss");
	var  bbsObj  = document.getElementById("act_bbs");
	if (v == "tips") {
		tipsObj.style.display = "block";
		rssObj.style.display = "none";
		bbsObj.style.display = "none";
	} else if (v == "rss") {
		tipsObj.style.display = "none";
		rssObj.style.display = "block";
		bbsObj.style.display = "none";
	} else {
		tipsObj.style.display = "none";
		rssObj.style.display = "none";
		bbsObj.style.display = "block";
	}
}

function onFlipBack() {}
// 設定が終わって、表に戻ったところで、設定を反映させる
function onFlipFront() {
	Pref.save("act");
	Pref.save("section");
	Pref.save("rssLocation");
	Pref.save("skin");
	document.getElementById("mainImg").src = "Images/"+Pref.getValue("skin")+".png";
	
	ACTOR.removeActor();
	setActor();
	ACTOR.initSection(true);
}

function setActor() {
	if (Pref.getValue("act") == "tips") {
		ACTOR = new ActorTips();
	} else if (Pref.getValue("act") == "rss") {
		ACTOR = new ActorRSS();
	} else {
		ACTOR = new ActorBBS();
	}
}

//--
// 画像の更新
function updateImg(aImg) {
	if (timeoutID != null) {
		clearTimeout(timeoutID);
		timeoutID = null;
	}

	if (aImg == "idle" ) {
		timeoutID = setTimeout("updateImg('wink');", Math.random()*10000+700);
	} else 	if (aImg == "wink" ) {
		aImg = "close";
		timeoutID = setTimeout("updateImg('idle');", 400);
	} else {
		timeoutID = setTimeout("updateImg('idle');", 8000);
	}

	document.getElementById("faceImg").src = "Images/face/"+aImg+".png";
}

// 現われたら、台詞をアップデート
function onshow() {
	ACTOR.dialog();
}

// 隠れた時はアニメ停止
function onhide() {
	if (timeoutID != null) {
		clearTimeout(timeoutID);
		timeoutID = null;
	}
}

// 移動
function goSite() {
	if (window.widget) {
		widget.openURL("http://www.tonbi.jp/");
	} else {
		location.href = "http://www.tonbi.jp/";
	}
}
function goBBS() {
	if (window.widget) {
		widget.openURL("http://www.tonbi.jp/cgi-bin/mascot_jp/index.cgi");
	} else {
		location.href = "http://www.tonbi.jp/cgi-bin/mascot_jp/index.cgi";
	}
}
